/*
   aes.h for SmartDongle API version 3.2


   www.smartdongle.com

   MicroWorks, Inc.
   2808 North Cole Road
   Boise, ID 83704
*/
#ifndef _DEFINED_406D2031_F187_4478_B6BE_BF44857A530B
#define _DEFINED_406D2031_F187_4478_B6BE_BF44857A530B

#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

#ifndef uint8
#define uint8  unsigned char
#endif

#ifndef uint32
#define uint32 unsigned long int
#endif

typedef struct
{
    uint32 erk[64];     /* encryption round keys */
    uint32 drk[64];     /* decryption round keys */
    int nr;             /* number of rounds */
}
aes_context;

typedef struct
{
	uint8* data;
    uint32 AESblockSize;
	uint32 numberOfBlocks;	
} SmartDongleCipher;


int  aes_set_key( aes_context *ctx, uint8 *key, int nbits );
void aes_encrypt( aes_context *ctx, uint8 input[16], uint8 output[16] );
void aes_decrypt( aes_context *ctx, uint8 input[16], uint8 output[16] );


SmartDongleCipher * SmartDongleEncode(
    uint8 *plainText,
    uint32 plainTextLength,
    uint32 AESblockSize,
    uint8 *AESkey);

void SmartDongleDecode(SmartDongleCipher *cipher, uint8 *AESkey);

#if defined(__cplusplus) || defined(__cplusplus__)
}
#endif

#endif /* AES_H */
